searchNodes=[{"doc":"This module provides functions that you can use to interact directly with uploads and attachments.","ref":"Dropkick.html","title":"Dropkick","type":"module"},{"doc":"Caches an attachable by saving it on the provided directory under the &quot;cache&quot; prefix by default. When an attachable is cached we won't calculate any metadata information, the file is only saved to the directory. This function is usually usefull when you are doing async uploads - where you first save the file to a temporary location and only after some confirmation you actually move the file to its final destination. You probably want to clean this directory from time to time.","ref":"Dropkick.html#cache/2","title":"Dropkick.cache/2","type":"function"},{"doc":"","ref":"Dropkick.html#contextualize/1","title":"Dropkick.contextualize/1","type":"function"},{"doc":"Calls the underlyning storage's copy function. Check the module Dropkick.Storage for documentation about the available options.","ref":"Dropkick.html#copy/3","title":"Dropkick.copy/3","type":"function"},{"doc":"Calls the underlyning storage's delete function. Check the module Dropkick.Storage for documentation about the available options.","ref":"Dropkick.html#delete/2","title":"Dropkick.delete/2","type":"function"},{"doc":"Moves an attachble from its current destination to another one. This function can be used to &quot;promote&quot; cached attachments without having to worry about cleaning up the temporary directory.","ref":"Dropkick.html#move/2","title":"Dropkick.move/2","type":"function"},{"doc":"Calls the underlyning storage's put function. Check the module Dropkick.Storage for documentation about the available options.","ref":"Dropkick.html#put/2","title":"Dropkick.put/2","type":"function"},{"doc":"Calls the underlyning storage's read function. Check the module Dropkick.Storage for documentation about the available options.","ref":"Dropkick.html#read/2","title":"Dropkick.read/2","type":"function"},{"doc":"Stores an attachable by saving it on the provided directory under the &quot;store&quot; prefix by default. When an attachable is stored we'll calculate metadata information before moving the file to its destination.","ref":"Dropkick.html#store/2","title":"Dropkick.store/2","type":"function"},{"doc":"Creates a version of the attachment with some transformation. Transformations validated against an attachment content_type . The current transformations supported are: image/* Image transformations uses the image library behind the scenes {:thumbnail, size, opts} : Generates an image thumbnail, receives the same options as Image.thumbnail/3","ref":"Dropkick.html#transform/2","title":"Dropkick.transform/2","type":"function"},{"doc":"","ref":"Dropkick.html#url/2","title":"Dropkick.url/2","type":"function"},{"doc":"","ref":"Dropkick.html#version/2","title":"Dropkick.version/2","type":"function"},{"doc":"","ref":"Dropkick.Application.html","title":"Dropkick.Application","type":"module"},{"doc":"","ref":"Dropkick.Attachable.html","title":"Dropkick.Attachable","type":"protocol"},{"doc":"","ref":"Dropkick.Attachable.html#content/1","title":"Dropkick.Attachable.content/1","type":"function"},{"doc":"","ref":"Dropkick.Attachable.html#key/1","title":"Dropkick.Attachable.key/1","type":"function"},{"doc":"","ref":"Dropkick.Attachable.html#name/1","title":"Dropkick.Attachable.name/1","type":"function"},{"doc":"","ref":"Dropkick.Attachable.html#t:t/0","title":"Dropkick.Attachable.t/0","type":"type"},{"doc":"This modules provides a definition to specialized uploaders that can be used to specify custom upload workflows. A specialized uploader acts as a hook before calling the function at Dropkick and allow you to modify how the upload is handled.","ref":"Dropkick.Attachableer.html","title":"Dropkick.Attachableer","type":"behaviour"},{"doc":"See Dropkick.cache/2 for more information.","ref":"Dropkick.Attachableer.html#c:cache/2","title":"Dropkick.Attachableer.cache/2","type":"callback"},{"doc":"Provide a default URL if no upload was found","ref":"Dropkick.Attachableer.html#c:default_url/1","title":"Dropkick.Attachableer.default_url/1","type":"callback"},{"doc":"Overrides the filename used when the attachment is stored. The original filename will still be kept as a metadata.","ref":"Dropkick.Attachableer.html#c:filename/2","title":"Dropkick.Attachableer.filename/2","type":"callback"},{"doc":"See Dropkick.move/2 for more information.","ref":"Dropkick.Attachableer.html#c:move/1","title":"Dropkick.Attachableer.move/1","type":"callback"},{"doc":"Defines the default prefix that will be used to store and retrieve uploads.","ref":"Dropkick.Attachableer.html#c:storage_prefix/2","title":"Dropkick.Attachableer.storage_prefix/2","type":"callback"},{"doc":"See Dropkick.store/2 for more information.","ref":"Dropkick.Attachableer.html#c:store/2","title":"Dropkick.Attachableer.store/2","type":"callback"},{"doc":"Defines the transformations to be applied after saving attachments.","ref":"Dropkick.Attachableer.html#c:transforms/2","title":"Dropkick.Attachableer.transforms/2","type":"callback"},{"doc":"","ref":"Dropkick.Attachableer.html#using/1","title":"Dropkick.Attachableer.using/1","type":"macro"},{"doc":"Defines a series of validations that will be called before caching the attachment.","ref":"Dropkick.Attachableer.html#c:validate/2","title":"Dropkick.Attachableer.validate/2","type":"callback"},{"doc":"","ref":"Dropkick.Attachableer.html#t:option/0","title":"Dropkick.Attachableer.option/0","type":"type"},{"doc":"","ref":"Dropkick.Attachableer.html#t:transforms/0","title":"Dropkick.Attachableer.transforms/0","type":"type"},{"doc":"","ref":"Dropkick.Attachment.html","title":"Dropkick.Attachment","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"Dropkick.Attachment.html#cast/1","title":"Dropkick.Attachment.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"Dropkick.Attachment.html#dump/1","title":"Dropkick.Attachment.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Dropkick.Attachment.html#embed_as/1","title":"Dropkick.Attachment.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Dropkick.Attachment.html#equal?/2","title":"Dropkick.Attachment.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"Dropkick.Attachment.html#load/1","title":"Dropkick.Attachment.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"Dropkick.Attachment.html#type/0","title":"Dropkick.Attachment.type/0","type":"function"},{"doc":"","ref":"Dropkick.Storage.html","title":"Dropkick.Storage","type":"behaviour"},{"doc":"Copies the given attachment with the underlyning storage module. When the attachment storage is set to Disk , we always attempt to read the file from its key. The underlyning implementation should accept the following options (besides any specific options): :move : Specifies if the file should be just copied or moved entirely, defaults to false . Returns a success tuple with the attachment in the new destination like: {:ok, %Attachment{}} .","ref":"Dropkick.Storage.html#c:copy/3","title":"Dropkick.Storage.copy/3","type":"callback"},{"doc":"Deletes the given attachment with the underlyning storage module. Diferently from the read and copy actions that takes into consideration the current attachment's storage. This function assumes the attachment being deleted uses the configured storage. So, if your current attachment is configured as Disk and you try to delete an attachment which storage is setup as Memory , the call will fail.","ref":"Dropkick.Storage.html#c:delete/2","title":"Dropkick.Storage.delete/2","type":"callback"},{"doc":"Stores the given attachable with the underlyning storage module. The underlyning implementation should accept the following options (besides any specific options): :folder : The base location where to save the file being transfered. :prefix : A sub-folder inside the current location where the file is going to be saved, defaults to / . Returns a success tuple like {:ok, %Attachment{status: :stored}} .","ref":"Dropkick.Storage.html#c:put/2","title":"Dropkick.Storage.put/2","type":"callback"},{"doc":"Reads the given attachment with the underlyning storage module. When the attachment storage is set to Disk , we always attempt to read the file from its key. Otherwise, we resort to the definition of Attachable.content/1 so we can also read remote files if necessary. Returns a success tuple with the content of the file like: {:ok, content} .","ref":"Dropkick.Storage.html#c:read/2","title":"Dropkick.Storage.read/2","type":"callback"},{"doc":"","ref":"Dropkick.Storage.html#t:option/0","title":"Dropkick.Storage.option/0","type":"type"},{"doc":"","ref":"Dropkick.Storage.Disk.html","title":"Dropkick.Storage.Disk","type":"module"},{"doc":"","ref":"Dropkick.Storage.Memory.html","title":"Dropkick.Storage.Memory","type":"module"},{"doc":"Dropkick is a highly experimental library that provides easy to use uploads for the Elixir/ Phoenix ecosystem. This is a opinionated library focused on developer ergonomics that you can use to provide file uploads in any Phoenix project. Some inspiration was taken from other projects like Capsule and Waffle as well as Ruby's Shrine .","ref":"README.html","title":"Dropkick","type":"extras"},{"doc":"def deps do [ { :dropkick , &quot;&gt;= 0.0.0&quot; } ] end","ref":"README.html#installation","title":"Dropkick - Installation","type":"extras"},{"doc":"Increase test coverage Implement more image transformations Add video transformations Add support to S3 storage","ref":"README.html#missing-bits","title":"Dropkick - Missing bits","type":"extras"}]